<template>
    <div class="app-container">
        <div class="filter-container">
            <div style="display: block;">
                <div class="basic_search" style="margin-right: 10px;padding-top: 10px">
                    <el-button style="margin-left: 10px;" type="primary" @click="addStock()">创建库区</el-button>
                </div>
            </div>
        </div>
        <div class="table_content">
            <el-table
                v-loading="listLoading"
                :key="tableKey"
                :data="stateStockData"
                :span-method="objectSpanMethod" :cell-class-name="tableRowClassName" @cell-mouse-leave="cellMouseLeave"  @cell-mouse-enter="cellMouseEnter"
                border
                fit
                highlight-current-row
                style="width: 100%;"
            >
                <el-table-column label="区域" align="center">
                    <template slot-scope="scope">
                        <el-link type="primary" @click="digDetail(scope.row)">{{ scope.row.region }}</el-link>
                    </template>
                </el-table-column>
                <el-table-column label="库区名称" prop="" align="center"></el-table-column>
                <el-table-column label="所属企业" prop="" align="center"></el-table-column>
                <el-table-column label="库区面积" prop="" align="center"></el-table-column>
                <el-table-column label="有效存储总面积" prop="" align="center"></el-table-column>
                <el-table-column label="核药量" prop="" align="center"></el-table-column>
                <el-table-column label="地址" prop="" align="center"></el-table-column>
                <el-table-column label="库房名称" prop="" align="center">
                    <template slot-scope="scope">
                        <el-link type="primary" @click="openRecord(scope.row)"></el-link>
                    </template>
                </el-table-column>
                <el-table-column label="库房面积" prop="" align="center"></el-table-column>
                <el-table-column label="有效存储面积" prop="" align="center"></el-table-column>
                <el-table-column label="等级" prop="" align="center"></el-table-column>
                <el-table-column label="库容量" prop="" align="center"></el-table-column>
                <el-table-column label="核药量" prop="" align="center"></el-table-column>
                <el-table-column label="当前总库存" prop="" align="center"></el-table-column>
                <el-table-column label="本公司库存" prop="" align="center"></el-table-column>
                <el-table-column label="爆竹类（箱）" prop="baozhuCount" align="center"></el-table-column>
                <el-table-column label="喷花类（箱）" prop="penhuaCount" align="center"></el-table-column>
                <el-table-column label="旋转类（箱）" prop="xuanzhuanCount" align="center"></el-table-column>
                <el-table-column label="吐珠类（箱）" prop="tuzhuCount" align="center"></el-table-column>
                <el-table-column label="玩具类（箱）" prop="wanjuCount" align="center"></el-table-column>
                <el-table-column label="组合烟花类（箱）" prop="zuheCount" align="center"></el-table-column>
                <el-table-column label="操作" align="center" width="120" class-name="small-padding fixed-width" fixed="right">
                    <template slot-scope="scope">
                        <el-button type="text" @click="showEnterprises(scope.row)">存货企业</el-button>
                        <el-button type="text" @click="deliverUsage(scope.row)">分配使用权</el-button>
                    </template>
                </el-table-column>
                <el-table-column label="是否允许盘库" align="center" width="120" class-name="small-padding fixed-width" fixed="right">
                    <template slot-scope="scope">
                        <span type="text">否</span>
                        <el-button type="text" @click="stockEdit(scope.row)">允许盘库</el-button>
                    </template>
                </el-table-column>
            </el-table>
            <br>
            <add-stock ref="addStock"></add-stock>
            <deliver-usage ref="deliverUsage"></deliver-usage>
            <stock-records ref="stockRecords"></stock-records>
            <edit-stock ref="editStock"></edit-stock>
        </div>
    </div>
</template>

<script>
import {computePageCount} from "../../utils";
import {getCityListData, getProvinceListData} from "../../api/area"
import {regionPifaBox} from "../../api/stock"
import addStock from "./components/addStock"
import deliverUsage from "./components/deliverUsage"
import stockRecords from "./components/stockRecords"
import editStock from "./components/editStock"
import Cookies from "js-cookie"
export default {
    name: "stockManage",
    components: {addStock,deliverUsage,stockRecords,editStock},
    data() {
        return {
            tableKey: '',
            provinceList: [],
            cityList: [],
            districtList: [],
            Cookies: Cookies,
            listLoading: false,
            stateStockData: [],
        }
    },
    created() {
        const t = this
        // setTimeout(()=>{
        //     t.$refs.deliverUsage.open()
        // },1000)
    },
    mounted() {
    },
    watch: {},
    methods: {
        addStock(){
            const t = this
            t.$refs.addStock.open()
        },
        openRecord(row){
            const t = this
            t.$refs.stockRecords.open()
        },
        deliverUsage(row){
            const t = this
            t.$refs.stockRecords.open()
        },
        // async getRegionPifaBox() {
        //     let res = await regionPifaBox()
        //     if (res.data.code === "200") {
                // const stateStockData = res.data.result || []
                // if(Array.isArray(stateStockData)){
                //     stateStockData.map(item=>{
                //         if(Array.isArray(item.enterprises)){
                //             item.enterprises.map((subRes, subIndex)=>{
                //                 let content = {}
                //                 content = subRes
                //                 content['area'] = item.area
                //                 content['enterpriseNum'] = item.enterpriseNum
                //                 // 重点！赋值合并的行数数值，只需要取子循环的第一个数赋值待合并的行数即可
                //                 if(subIndex == 0){
                //                     content['rowNum'] = item.enterprises.length
                //                 }
                //                 t.tableRowData.push(content)
                //             })
                //         }
                //     })
                // }
        //     } else {
        //         this.$message({
        //             type: 'warning',
        //             message: res.data.message
        //         })
        //     }
        //     this.listLoading = false
        // },
        digDetail(row){
        },

        stockEdit(row){
            const t = this
            t.$refs.editStock.open()

        },
        objectSpanMethod({ row, column, rowIndex, columnIndex }) {
            // columnIndex 代表列数，从0开始计数,我们要合并的字段属于第一列，取0
            if(columnIndex <=7){
                return {
                    rowspan: row.rowNum, // 待合并行数 -- 合并的行数长度就等于之前赋值的子数据的长度；未赋值的即表示0，不显示
                    colspan: row.rowNum>0?1:0  // 待合并列数 -- 合并的列数自身占一列，被合并的要返回0，表示不显示
                };
            }
        },
        tableRowClassName({row,rowIndex}) {
            let arr = this.hoverOrderArr
            for (let i = 0; i < arr.length; i++) {
                if (rowIndex == arr[i]) {
                    return 'hovered-row'
                }
            }
        },
        cellMouseEnter(row, column, cell, event) {
            this.rowIndex = row.rowIndex;
            this.hoverOrderArr = [];
            this.OrderIndexArr.forEach(element => {
                if (element.indexOf(this.rowIndex) >= 0) {
                    this.hoverOrderArr = element
                }
            })
        },
        cellMouseLeave(row, column, cell, event) {
            this.rowIndex = '-1'
            this.hoverOrderArr = [];
        },
    },
}
</script>

<style scoped>
.basic_search {
    display: inline-block;
}
</style>
